// file      : xsd/cxx/tree/generator.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005-2006 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef CXX_TREE_GENERATOR_HXX
#define CXX_TREE_GENERATOR_HXX

#include <cult/types.hxx>

//@@ SemanticGraphFwd could be useful here.
//
#include <xsd-frontend/semantic-graph.hxx>

#include <cxx/tree/cli.hxx>

namespace CXX
{
  namespace Tree
  {
    using namespace Cult::Types;

    class Generator
    {
    public:
      static Void
      usage ();

      static CLI::OptionsSpec
      options_spec ();

      struct Failed {};

      Void
      generate (CLI::Options const& options,
                XSDFrontend::SemanticGraph::Schema&,
                XSDFrontend::SemanticGraph::Path const& file);
    };
  }
}

#endif // CXX_TREE_GENERATOR_HXX
